import numpy as np
import matplotlib.pyplot as plt
import numpy.random as random

class Investor():
    
    def __init__(self):
        self.out_of_market = False
        self.buy = False
        self.sell = False
        self.idle = False
        self.price = 0.

NInvestors = 1000
passLevel = .15
tick_price = [100.]
daily_price = [100.]
volume = [0]
logB = []
logS = []
nrun = 10000

time_series = [tick_price, daily_price, volume]
time_series_labels = ['Tick.PriceCDA', 'PriceCDA', 'VolumeCDA']

def store_data ():
    for i,this_time_series in enumerate(time_series):
        f = open(time_series_labels[i] + '.csv', 'w')
        f.write(time_series_labels[i] + '\n')
        for item in this_time_series:
            f.write('%f\n' % item)
        f.close()

##############################################################
Investors = []
for i in range(NInvestors):
    investor = Investor()
    Investors.append(investor)

for i in range(nrun):
    print i
    today_volume = 0
    today_price = 0
    for investor in Investors:
        if not investor.out_of_market:
            if random.random() < passLevel:
                investor.idle = True
            else:
                investor.idle = False
        if not investor.idle:
            if random.random() < .5:
                investor.buy = True
                investor.sell = False
            else:
                investor.buy = False
                investor.sell = True
        investor.price = tick_price[-1] + random.normal(0, 10)
    
    logB = []
    logS = []

    for investor in Investors:
        if not investor.idle and not investor.out_of_market:
            if investor.buy:
                logB.append(investor.price)
                logB = sorted(logB)
                if (len(logB) > 0 and len(logS) > 0 and logB[-1] >= logS[-1]):
                    today_volume += 1
                    tick_price.append(logS[-1])
                    del logB[-1]
                    del logS[-1]
            if investor.sell:
                logS.append(investor.price)
                logS = sorted(logS)[::-1]
                if (len(logB) > 0 and len(logS) > 0 and logB[-1] >= logS[-1]):
                    today_volume += 1
                    tick_price.append(logB[-1])
                    del logB[-1]
                    del logS[-1]

    volume.append(today_volume)
    daily_price.append(tick_price[-1])

store_data()

#plt.plot(daily_price)
#plt.plot(volume)
#plt.plot(tick_price)
#plt.show()


                


                
    

